module Names.Aarakocra exposing (female, lastName, male)

{-| This module exposes a generator for Aarakocra names.

For more name generators, make sure to check out <https://www.fantasynamegenerators.com/>


# Copyright (C) 2012 - 2020 FantasyNameGenerators.com.

-}

import Names.Tools as Tools
import Random exposing (Generator)
import String.Extra


female : Generator String
female =
    Tools.chooseFrom2
        (Tools.map3 nm1 nm2 nm3)
        (Tools.map5 nm1 nm2 nm3 nm4 nm5)
        |> Random.map String.Extra.toTitleCase


male : Generator String
male =
    female


lastName : Generator String
lastName =
    female


nm1 : Generator String
nm1 =
    Random.uniform ""
        [ ""
        , ""
        , ""
        , ""
        , "c"
        , "cl"
        , "cr"
        , "d"
        , "g"
        , "gr"
        , "h"
        , "k"
        , "kh"
        , "kl"
        , "kr"
        , "q"
        , "qh"
        , "ql"
        , "qr"
        , "r"
        , "rh"
        , "s"
        , "y"
        , "z"
        ]


nm2 : Generator String
nm2 =
    Random.uniform "a"
        [ "e"
        , "i"
        , "u"
        , "a"
        , "e"
        , "i"
        , "u"
        , "a"
        , "e"
        , "i"
        , "u"
        , "a"
        , "e"
        , "i"
        , "u"
        , "a"
        , "e"
        , "i"
        , "u"
        , "a"
        , "e"
        , "i"
        , "u"
        , "a"
        , "e"
        , "i"
        , "u"
        , "ae"
        , "aia"
        , "ee"
        , "oo"
        , "ou"
        , "ua"
        , "uie"
        ]


nm3 : Generator String
nm3 =
    Random.uniform "c" [ "cc", "k", "kk", "l", "ll", "q", "r", "rr" ]


nm4 : Generator String
nm4 =
    Random.uniform "a"
        [ "e"
        , "i"
        , "a"
        , "e"
        , "i"
        , "a"
        , "e"
        , "i"
        , "a"
        , "e"
        , "i"
        , "a"
        , "e"
        , "i"
        , "aa"
        , "ea"
        , "ee"
        , "ia"
        , "ie"
        ]


nm5 : Generator String
nm5 =
    Random.uniform ""
        [ ""
        , ""
        , ""
        , "c"
        , "ck"
        , "d"
        , "f"
        , "g"
        , "hk"
        , "k"
        , "l"
        , "r"
        , "rr"
        , "rc"
        , "rk"
        , "rrk"
        , "s"
        , "ss"
        ]
